<?php
/**
 * @file clase_zen_html_modelo_datos.php
 * @author Juan Belon
 * @access public
 * @copyright LGPL, GPL
 * @package zenphp
 * @version 1.0
 * @uses zenphp FrameWork
 * 
 * @brief Clase que genera un visualizador HTML para un modelo de datos 
 * //TODO:por venir : scaffolding
 */
// +----------------------------------------------------------------------
// | zenphp.es
// +----------------------------------------------------------------------
if (!defined('ZF_SEGURO_ZEN')) exit('Acceso directo no permitido');
class zen_html_modelo_datos {
	/**
	 * Clase modelo de datos asociada a la clase HTML
	 *
	 * @var zen_modelo_datos
	 */
	var $padre;
	/**
	 * Constructor
	 *
	 * @param zen_modelo_datos $_padre
	 * @return zen_html_modelo_datos
	 */
	function zen_html_modelo_datos(&$_padre){
		$this->padre =& $_padre;
		//Esta clase depende sobre todo de las plantillas
		if (!zen___carga_clase('zen_plantilla')) die('No se pudo cargar la clase plantillas de zenphp');
	}
	/**
	 * Utilizando una clase plantilla y un fichero HTML devuelve el contenido relleno con los datos.
	 * Si rellenamos $fichero_base ,se colocan los datos del listado dentro de la base ,sustituyendolo por la $marca_base
	 * Si alguna de $reemplazos_base o $reemplazos_datos tiene contenido, se reemplazan previamente en su correspondiente plantilla
	 *
	 * @param str $fichero
	 * @param str $fichero_base
	 * @param str $marca_base
	 * @param array|null $reemplazos_base
	 * @param arrat|null $reemplazos_datos
	 * @return str : html
	 */
	function listado($fichero,$fichero_base="",$marca_base="",$reemplazos_base=null,$reemplazos_datos=null){
		$p =& new zen_plantilla($fichero);
		$datos = $this->padre->obtener();
		if (is_array($reemplazos_datos)) $p->pasarAplantilla($reemplazos_datos);
		$aux = $p->contenido;
		
		$html = "";
		for ($i=0; $i<sizeof($datos); $i++){
			$p->contenido = $aux;
			$p->pasarAplantilla($datos[$i]);
			$html .= $p->contenido;
		}
		if (!empty($fichero_base) && !empty($marca_base)){
			$p2= $p;
			$p2->cargar($fichero_base);
			if (is_array($reemplazos_base))	$p2->pasarAplantilla($reemplazos_base);
			$p2->reemplazar($marca_base , $html);
			return $p2->contenido;
		} else return $html;
	}
	/**
	 * Obtiene un registro de la BD con id de la lista de campos de las tablas y devuelve el HTML. Necesita la plantilla donde se reemplazan los datos...
	 * El $fichero_plantilla se carga para meterle los datos del modelo_datos y los $reemplazos son un array que se reemplaza previamente en la plantilla por si le falta algo extra al modelo_datos
	 *
	 * @param str $fichero_plantilla
	 * @param str $reemplazos 
	 * @return str :html
	 */
	function editar($fichero_plantilla,&$reemplazos){
		$p =& new zen_plantilla();
		if (!$p->cargar($fichero_plantilla)) return false;
		$c = split(",",$this->padre->campos);
		$tupla = array();
		if (isset($_REQUEST[$c[0]]))
		{
			$tupla = $this->padre->obtener($this->padre->campos,""," where ".$c[0]."=".intval($_REQUEST[$c[0]]),""," limit 1");
			if (!$tupla) return "Sin datos";
		}
		//Primero los reemplazos de usuario
		$p->pasarAplantilla($reemplazos);
		//Despues los datos del modelo de datos:
		if (count($tupla)>0)
		 $p->pasarAplantilla($tupla[0]);
		return $p->contenido;
	}
	/**
	 * Muestra un registro en concreto usando una plantilla
	 *
	 * @param int $id
	 * @param str $fichero_plantilla
	 * @return str : html
	 */
	function mostrar($id,$fichero_plantilla,$reemplazos){
		if (!$this->padre->existe($id)) return "Sin datos";
		$p =& new zen_plantilla();
		$campos = split(",",$this->padre->campos);		
		if (!is_array($reemplazos)) $reemplazos = array();
		return $p->contenido_reemplaza($fichero_plantilla, //Mete en la plantilla el contenido
		array_merge( //de los arrays de datos con el identificador y los reemplazos previos juntos
			$this->padre->obtener_primero("","","where ".$campos[0]."=".intval($id),"","limit 1"),
			$reemplazos
		));
	}
	
}
?>